import cv2

from wormpose.dataset.base_dataset import BaseFramePreprocessing
from wormpose.dataset.image_processing.image_utils import segment_foreground


class SimpleFramePreprocessing(BaseFramePreprocessing):

    def __init__(self):
        self.blur_kernel = (5, 5)
        self.foreground_dilate_struct_element = cv2.getStructuringElement(cv2.MORPH_ELLIPSE, (5, 5))
        self.foreground_close_struct_element = cv2.getStructuringElement(cv2.MORPH_ELLIPSE, (3, 3))

    def run(self, frame):

        foreground_mask, average_background_color = segment_foreground(frame,
                                                                       self.blur_kernel,
                                                                       self.foreground_close_struct_element,
                                                                       self.foreground_dilate_struct_element)
        # erase background, set everything not the foreground to a uniform color
        frame[foreground_mask == 0] = average_background_color

        return frame
