import cv2
import numpy as np


def template_match(source_image, template_image):

    score_map = cv2.matchTemplate(source_image, template_image, method=cv2.TM_CCOEFF_NORMED)
    _, score, _, score_loc = cv2.minMaxLoc(score_map)

    return score, score_loc


def fit_bounding_box_to_synth_image(synth_image, background_color, padding=2):

    where_mask = np.where(synth_image != background_color)
    if len(where_mask[0]) > 0 and len(where_mask[0]) > 0:
        left, right, bottom, top = max(0, np.min(where_mask[0]) - padding), \
                                   min(synth_image.shape[0], np.max(where_mask[0]) + 1 + padding), \
                                   max(0, np.min(where_mask[1]) - padding), \
                                   min(synth_image.shape[1], np.max(where_mask[1]) + 1 + padding)
    else:
        left, right, bottom, top = 0, -1, 0, -1

    return left, right, bottom, top