import tensorflow as tf


def symmetric_angle_difference(y_true, y_pred):

    def angle_diff(a, b):
        diff = tf.atan2(tf.sin(a - b), tf.cos(a - b))
        return tf.sqrt(tf.reduce_sum(input_tensor=diff * diff, axis=1))

    dists = [angle_diff(y_pred, y_true[:, 0]), angle_diff(y_pred, y_true[:, 1])]
    mins = tf.reduce_min(input_tensor=dists, axis=0)
    loss = tf.reduce_mean(input_tensor=mins)
    return loss