from abc import ABC, abstractmethod


class BasePosturesModel(ABC):
    """
    Base class to subclass to implement a worm postures model
    """

    @abstractmethod
    def generate(self):
        """
        :return: an infinite generator that yields centerline angles for one frame:
         numpy floating point array of shape [S] where S=length of the theta vector
        """
        pass
